function [betahatj1, betavarj1, betastd,betahat1,betahat2 ]=ardlpmg_vj(y,x, kappa, p)

[T,n,k]=size(x);
Th=zeros(n,1);
Tind=[1:T]';
Tia=zeros(n,1);

Tsa=zeros(n,1);
Tea=zeros(n,1);
Tsb=zeros(n,1);
Teb=zeros(n,1);

x1=NaN(T,n,k); x2=NaN(T,n,k);
y1=NaN(T,n);  y2=NaN(T,n);
for i=1:n
    xi=squeeze(x(:,i,:));
    yi=y(:,i);
    isob=sum(isnan([yi,xi]),2)==0;
    Ts=min(Tind(isob)); Tsa(i,1)=Ts;
    Te=max(Tind(isob));
    Ti=sum(isob); Tia(i,1)=Ti;
    Th(i,1)=floor((Ti+p)/2);  
    
    Tsa(i,1)=Ts; Tea(i,1)=Ts+Th(i,1)-1;
    Tsb(i,1)=Ts+Th(i,1)-1; Teb(i,1)=Te;
        
    x1(Ts:Ts+Th(i,1)-1,i,:)=x(Ts:Ts+Th(i,1)-1,i,:); 
    y1(Ts:Ts+Th(i,1)-1,i)=y(Ts:Ts+Th(i,1)-1,i);
    x2(Ts+Th(i,1)-1:Te,i,:)=x(Ts+Th(i,1)-1:Te,i,:); 
    y2(Ts+Th(i,1)-1:Te,i)=y(Ts+Th(i,1)-1:Te,i);
end

La=Tea-Tsa+1;
Lb=Teb-Tsb+1;
[betahat, xim, sx]=ardlpmgs(y,x);
[betahat1, xima]=ardlpmgs(y1,x1);
[betahat2, ximb]=ardlpmgs(y2,x2);
ximaf=zeros(size(xim)); ximbf=zeros(size(ximb));
for i=1:n
   
    ximaf(Tsa(i,1)+1:Tea(i,1),:,i)=xima(Tsa(i,1)+1:Tea(i,1),:,i);
    ximbf(Tsb(i,1)+1:Teb(i,1),:,i)=ximb(Tsb(i,1)+1:Teb(i,1),:,i);
end

betahatj1=betahat-kappa*((betahat1+betahat2)/2-betahat);
ximf=zeros(size(xim));
for i=1:n
    ximf(:,:,i)=xim(:,:,i)*(eye(k)+kappa)-ximaf(:,:,i)*(kappa/2)*4-ximbf(:,:,i)*(kappa/2)*4;
end
% now compute variance

Tb=mean(Tia);
sv=0;

for i=1:n
    %i
 xi=squeeze(x(:,i,:));
 yi=y(:,i);
 
      
    vinma= (yi(Tsa(i,1)+1:Tea(i,1),1)-xi(Tsa(i,1)+1:Tea(i,1),:)*betahatj1);
    vinmb= (yi(Tsb(i,1)+1:Teb(i,1),1)-xi(Tsb(i,1)+1:Teb(i,1),:)*betahatj1);
    a=squeeze(ximf( Tsa(i,1)+1:Tea(i,1),:,i));
    b=squeeze(ximf( Tsb(i,1)+1:Teb(i,1),:,i));
    c=(a'*vinma+b'*vinmb); %/Tia(i,1)

    
    sv=sv+c*c'; %/n
end
OM=inv(sx)*sv*inv(sx);
betavarj1=OM;
betastd=diag(betavarj1).^0.5;

return