function [betahat, xim, sx]=ardlpmgs(y,x)

[T,n,k]=size(x);
xim=NaN(T,k,n);
% estimation
sx=0; sy=0;
Tind=[1:T]';
for i=1:n
 xi=squeeze(x(:,i,:));
 yi=y(:,i);
 % find available sample (time periods with NaNs are dropped)
 ni=isnan([yi,xi]);  isob=sum(isnan([yi,xi]),2)==0;
 omit=(sum(ni,2)>0); 
 yi=yi(not(omit));
 xi=xi(not(omit),:);
 Ti=size(yi,1);

 Ts=min(Tind(isob));
 Te=max(Tind(isob));
 
% vi=uy(2:T,i)/alpha;
 Wi=[yi(2:Ti,1)-yi(1:Ti-1,1),xi(2:Ti,:)-xi(1:Ti-1,:), ones(Ti-1,1)]; 
 Hi=[yi(1:Ti-1,1),xi(2:Ti,:),xi(1:Ti-1,:), ones(Ti-1,1)]; %, ones(T-1,1)
P=Hi*inv(Hi'*Hi)*Hi';
M=P-P*Wi*inv(Wi'*P*Wi)*Wi'*P;
%Mw=eye(T-1)-Wi*inv(Wi'*Wi)*Wi';

% M1=Mw*P*Mw;
% beta1=inv(xi'*M*xi)*xi'*M*yi
% beta2=inv(xi'*M1*xi)*xi'*M1*yi
% % ARDL estim
% X=[y(1:T-1,i), x(2:T,i), x(1:T-1,i)]; %v
% a=X\yi;
% betaa=(a(2)+a(3))/(1-a(1))

%[xi'*P;xi']
ximi=M*xi(2:Ti,:);
sx=sx+ximi'*ximi;
sy=sy+xi(2:Ti,:)'*M*yi(2:Ti,1);
xim(Ts+1:Te,:,i)=ximi;
end
betahat=inv(sx)*sy;

return