function [yr,xr]=gen_data_ardlbc(Q,ys, xs,T)

n=size(ys,2);

yr=zeros(T,n);
xr=zeros(T,n);

yr(1,:)=ys;
xr(1,:)=xs;

% generate residuals
u=Q.u;
v=Q.v;
% stdu=std(u);
% stdv=std(v);
% ur=randn(T,n).*(ones(T,1)*stdu);
% vr=randn(T,n).*(ones(T,1)*stdv);
ur=zeros(T,n);
vr=zeros(T,n);
% for i=1:n
%     ind =   ceil(rand(T,1)*(T-1));
%     ur(:,i)=u(ind,i);
%     vr(:,i)=v(ind,i);
% end
ku=(rand(T-1,n)<0.5)*(-2)+1;
kv=(rand(T-1,n)<0.5)*(-2)+1;
ur(2:T,:)=u.*ku;
vr(2:T,:)=v.*kv;
for t=2:T
    xr(t,:)=xr(t-1,:)+ur(t,:);
    yr(t,:)=yr(t-1,:)+Q.c'+Q.alpha'.*(yr(t-1,:)-Q.beta*xr(t-1,:))+Q.delta'.*(xr(t,:)-xr(t-1,:))+vr(t,:); 
end

return