function Q=pmg_full(y,x)

[T,n]=size(x);

[betahat, stdbeta]=PMGe(y,x,1);

% estimate alphai and report residuals
alpha=zeros(n,1); delta=zeros(n,1); c=zeros(n,1); v=zeros(T-1,n);
for i=1:n
    dyi=y(2:T,i)-y(1:T-1,i);
    ex=y(1:T,i)-betahat*x(1:T,i);
    X=[ex(1:end-1,1),ones(T-1,1),x(2:T,i)-x(1:T-1,i)];
    b=X\dyi;
    alpha(i,1)=b(1,1);
    delta(i,1)=b(3,1);
    c(i,1)=b(2,1);
    v(:,i)=(dyi-X*b)';
end
u=x(2:T,:)-x(1:T-1,:);

% assign values
Q.beta=betahat;
Q.alpha=alpha;
Q.delta=delta;
Q.c=c;
Q.v=v;
Q.u=u;
%Q.sx=sx;
Q.var=stdbeta^2;
return